#ifndef __MatriceImage_h__
#define __MatriceImage_h__

#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "CImg-1.3.0/CImg.h"

extern "C" {
	#include "CSparse/Include/cs.h"
};


using namespace cimg_library;


class MatriceImage {
  
  int sizex; // width of the image
  int sizey; // height of the image
  
  double* matR; // One-dimensional array, stocking Red components
  double* matG; // idem for Green
  double* matB; // and Blue 
  
public:
  
  MatriceImage(CImg< double > im);
  // Constructor : from a CImg image
  
  CImg<unsigned char> creerIm();
  // Create a CImg imaage from this

  void computeWLS ( double alpha, double lambda);
  // Compute WLS filter with alpha and lambda parameters (cf. paper)

  /* void get_log(double eps);
     void get_exp(double eps);*/
  ~MatriceImage();
  // destructor

};// end class def

#endif
