#include <iostream>
#include <string>
#include <cmath>
#include "CImg-1.3.0/CImg.h"
#include "Toon.h"



using namespace cimg_library;
using namespace std;


Toon::Toon(CImg<double> im) : im_fond(im), im_bord(im.dimx(), im.dimy(), 1, 1, 0.0), sizex(im.dimx()), sizey(im.dimy())
{
}


void Toon::sobel(double atenuation, int seuil){
  cout << im_bord.ptr()<< endl;
  CImg<double> Gx(3, 3);
  CImg<double> Gy(3, 3);
  CImg<double> temp(3, 3);
  double *pointeur;
  double valeur;
  //Matrices de convolution
  Gx.fill(-1.0, 0.0, 1.0, -2.0, 0.0, 2.0, -1.0, 0.0, 1.0);
  Gy.fill(1.0, 2.0, 1.0, 0.0, 0.0, 0.0, -1.0, -2.0, -1.0);


  //On applique l'algorithme de sobel
  im_bord=im_fond.get_convolve(Gx);
  im_bord.pow(2);
  temp=im_fond.get_convolve(Gy);
  temp.pow(2);
  im_bord+=temp;
  im_bord.sqrt();



  //On transforme l'image en dégradé de gris
  //Representant la norme des couleurs
  pointeur = im_bord.ptr();
  cout << sizex << "/" << sizey << endl;
  for (int i = 0; i<sizex*sizey; i++){
    valeur = pow(*(pointeur+i), 2);
    valeur +=pow(*(pointeur+sizex*sizey+i), 2);
    valeur +=pow(*(pointeur+2*sizex*sizey+i), 2);
    valeur=pow(valeur, atenuation);
    if (valeur<=seuil) {
      valeur=seuil*pow(valeur/seuil,4);
    }

    *(pointeur+i) = valeur;
    //*pointeur[i] = valeur;
    *(pointeur+sizex*sizey+i) = valeur;
    *(pointeur+2*sizex*sizey+i)= valeur;
  }
  ~Gx;~Gy;~temp;

  
}

//Fonction de quantification
//Escalier à pente finie
int quantize(double val, int nombre, float eps){
  double out;
  int indice = floor(nombre*val/100);
  double espace = 100.0 /nombre;

  double val_espace = val - floor(val/ espace)*espace;
  
  if (val_espace<(espace-eps)/2){ out = 0;}
  else if (val_espace >(espace+eps)/2){out=1;}
  else {out = (val_espace-(espace-eps)/2)*1/eps;}

  out = out*espace + indice*espace;

  return out;
}

void Toon::quantifier(int nb_intensite){
  int valeur;
  im_fond.RGBtoLab();
  double *pointeur = im_fond.ptr();
  for (int i = 0; i<sizex*sizey; i++){
    valeur =*(pointeur+i);      
    *(pointeur+i) = quantize(valeur, nb_intensite, 0.3);
  }  
  im_fond.LabtoRGB();
  
}



CImg<unsigned char> Toon::bords(){
  return  (CImg<unsigned char>)(255*(1-im_bord/im_bord.max()));
}


CImg<unsigned char> Toon::fond(){
  return im_fond;
}


CImg<unsigned char> Toon::image(){
  return ((im_fond-3*im_bord).max(0));
}

Toon::~Toon(){
  ~im_fond;
  ~im_bord;
}
