#ifndef __Toon_h__
#define __Toon_h__

#include <iostream>
#include <string>
#include <cmath>
#include "CImg-1.3.0/CImg.h"



using namespace cimg_library;


class Toon {

  CImg<double> im_fond;
  CImg<double> im_bord;
  
public:

  int sizex;
  int sizey;
  
  Toon(CImg< double > im);
  //Constructor from a Cimg file

  void sobel(double atenuation=0.4, int seuil=50);
  //Create the edges layer
  //atenuation : the highter the most edges are taken into acount (usually beetween 0.3 and 0.6)
  //seuil : all edges of intensity under the seuil are suppressed (between 0 and 260)

  void quantifier(int nb_intensite=7);
  //Quantify the brightness of the picture 

  CImg<unsigned char> bords();
  //return the edges picture

  CImg<unsigned char> fond();
  //return the picture without egdes

  CImg<unsigned char> image();
  //return the picture with edges

  ~Toon();	

};// end class def

#endif
