/**
 *  File abstraire.cpp : application witch computes a picture
 *  to a cartoon.
 *
 *
 *  Syntaxe : ./abstraire <u0> <alpha>(opt.) <lambda>(opt.)
 *  where u0 is the original image
 *        alpha the first wls parameter (by default 2)
 *        lambda the second one (by default 0.6)
 * 
 */


#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "CImg-1.3.0/CImg.h"
#include "Toon.h"
#include "MatriceImage.h"


using namespace cimg_library;
using namespace std;

  


int main(int argc, char* argv[]) {

  CImg<double> image(argv[1]), imageres, imageres2;
  cout << image.dimx() << " X " << image.dimy() << endl;
  MatriceImage matim = MatriceImage(image);
  double alpha, lambda;
cout << argc << endl;
  if (argc>3){
	alpha = atof(argv[2]);
	lambda = atof(argv[3]);
  }else{
  	alpha = 2;
  	lambda = 0.6;
  }
  matim.computeWLS(alpha,lambda);
  imageres = matim.creerIm();

  //CImgDisplay fenetre=CImgDisplay();
  //CImgDisplay fenetre2=CImgDisplay();
  //CImgDisplay fenetre3=CImgDisplay();

  Toon dessin(imageres);

  dessin.sobel();
  dessin.quantifier();
  
  //fenetre2.display(imageres);
  //fenetre3.display(dessin.image());
  
  //fenetre.wait();
  //fenetre2.wait();
  //fenetre3.wait();

  
  (dessin.image()).save("toon.ppm");
  //(imageres).save("wls.ppm");

  return 0;
}
