/* 
 *  File abstraction_prof.cpp : application witch computes a picture
 *  to a cartoon with a depth image.
 *  
 *  Syntaxe : ./abstraction_prof <Image_source> <image depth> <alpha> <lambda>
 */



#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "CImg-1.3.0/CImg.h"
#include "MatriceImage.h"



int main(int argc, char* argv[]) {
  CImg<double> image(argv[1]);
  cout << image.dimx() << " X " << image.dimy() << endl;
  CImg<double> imageres;
  CImg<double> imageres2;
  CImg<double> prof(argv[2]);
  //CImg<double> prof_niv1(image.dimx(), image.dimy(), image.dimz(), image.dimz(), 0.0);
  //CImg<double> prof_niv2(image.dimx(), image.dimy(), image.dimz(), image.dimz(), 0.0);
  CImg<double> prof_niv1(argv[1]);
  CImg<double> prof_niv2(argv[1]);
  prof = 1- prof/prof.max();
  //Attention a la main 
  //Transformation de l'image en noir et blanc
  double *pointeur = prof.ptr();
  double *pointeur2 = prof_niv1.ptr();
  double *pointeur3 = prof_niv2.ptr();
  double valeur;
  for (int i=0; i<prof.dimx() * prof.dimy(); i++){
    valeur = (*(pointeur+i) + *(pointeur+prof.dimx()*prof.dimy() +i) + *(pointeur + 2*prof.dimx()*prof.dimy() +i)) /3;
    if(valeur>0.8){
      *(pointeur2+i) = 1;
      *(pointeur2+prof.dimx()*prof.dimy() +i) = 1;
      *(pointeur2 + 2*prof.dimx()*prof.dimy() +i) = 1;
    }
    else{
      *(pointeur2+i) = 0;
      *(pointeur2+prof.dimx()*prof.dimy() +i) = 0;
      *(pointeur2 + 2*prof.dimx()*prof.dimy() +i) = 0;
    }
    if(valeur>0.4 && valeur<0.8){
      *(pointeur3+i) = 1;
      *(pointeur3+prof.dimx()*prof.dimy() +i) = 1;
      *(pointeur3 + 2*prof.dimx()*prof.dimy() +i) = 1;
    } else{
      *(pointeur3+i) = 0;
      *(pointeur3+prof.dimx()*prof.dimy() +i) = 0;
      *(pointeur3 + 2*prof.dimx()*prof.dimy() +i) = 0;
    }
  }
  //***************
  prof.quantize(3);
  
  CImg<char> diff(image.dimx(), image.dimy(), image.dimz(), image.dimv(), (char)0);
  CImg<char> diff2(image.dimx(), image.dimy(), image.dimz(), image.dimv(), (char)0);
  MatriceImage matim = MatriceImage(image);
  double alpha = atof(argv[3]);
  double lambda = atof(argv[4]);

  matim.computeWLS(1, 0.2);
  image = matim.creerIm();
  
  matim.computeWLS(alpha,lambda);
  imageres = matim.creerIm();
  
  matim.computeWLS(1.5*alpha, 1.5*lambda);
  imageres2 = matim.creerIm();

  diff = (image-imageres2);
  diff2 = (imageres-imageres2);

  diff.mul(prof_niv1);
  diff2.mul(prof_niv2);

	  

  //imageres.display();
  //imageres2.display();
  //prof_niv1.display();
  //prof_niv2.display();
  //diff.display();
  //diff2.display();
  //(imageres2+diff+diff2).display();

  (imageres2+diff+diff2).save("result.ppm");
  
  
  ~image;
  ~imageres;
  return 0;
}

