/**
 *  File abstraire_v.cpp : application witch computes a list of pictures
 *  to a wls and a cartoon version.
 *  Wls pictures are saved in the folder "wls"
 *  Toon ones are saved in the folder "toon"
 *
 *  Syntaxe : ./abstraire <u0> <un> 
 *  where u0 is the first image computed
 *        un is the last one
 *
 *  Parameters for wls and cartoon are pre-defined :
 *  wls(2, 06)
 *  cartoon(0.4, 50) 
 *  
 */

#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "CImg-1.3.0/CImg.h"
#include "Toon.h"
#include "MatriceImage.h"


using namespace cimg_library;
using namespace std;

  


int main(int argc, char* argv[]) {

  CImg<double> image, imageres;
  cout << image.dimx() << " X " << image.dimy() << endl;
  double alpha = 2;
  double lambda = 0.6;


  int first = atoi(argv[3]), last = atoi(argv[4]);

  
  CImgDisplay fenetre=CImgDisplay();
  CImgDisplay fenetre2=CImgDisplay();
  CImgDisplay fenetre3=CImgDisplay();
  string base=argv[1], ext=argv[2], fichier, fichier2, fichier3;
  // créer un flux de sortie
  
  for (int i=first; i<=last; i++){
 
    // écrire un nombre dans le flux
    ostringstream oss;
    oss << i;
    // récupérer une chaîne de caractères
    fichier = base + oss.str()+"."+ext;
    fichier2 = "wls/" + base + oss.str()+"."+ext;
    fichier3 = "toon/"+base+oss.str()+"."+ext;


    
    image.load(fichier.c_str());
    cout << fichier << " : " << image.dimx() << " X " << image.dimy() << endl;
    MatriceImage matim = MatriceImage(image);
    
    matim.computeWLS(alpha,lambda);
    imageres = matim.creerIm();
    
    
    Toon dessin(imageres);
    
    dessin.sobel();
    dessin.quantifier();
        
    (dessin.image()).save(fichier3.c_str());
    (imageres).save(fichier2.c_str());
    
  }
  
  return 0;
}
