/**
 * Decomposition.c
 * Syntaxe : Decomposition <image source> <alpha> <lambda> <c> <u1> ... <uN>
 *
 */



#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "CImg-1.3.0/CImg.h"
#include "MatriceImage.h"



int main(int argc, char* argv[]) {
  CImg<double> image(argv[1]);
  CImg<double> imageres;
  MatriceImage matim = MatriceImage(image);
  double alpha = atof(argv[2]);
  double lambda = atof(argv[3]);
  double c = atof(argv[4]);

  for (int i = 5; i<argc; i++){
    matim.computeWLS(alpha,pow(c,i-5)*lambda);
    imageres = matim.creerIm();
    matim = MatriceImage(imageres);
    imageres.save(argv[i],-1);
  }

  /*
  imageres = matim.creerIm();
  cout << imageres.dimx() << " X " << imageres.dimy() << endl;

  image -= imageres;
  image = image.max(0);
  image *= 10;
  
  image.display();
  //imageres.display();
  
  if (argc == 5)
    
    imageres.save(argv[4],-1);
  */

  ~image;
  ~imageres;
  return 0;
}

