/**
 *  File recon.cpp : small application for visualizing
 *  multi-scale decomposition using WLSfilter
 *
 *
 *  Syntaxe : ./recon <u0> <u1> <u2> <save1> <save2> ... <saveN>
 *  where u0 is the original image
 *        u1 the first filtered one
 *        u2 the second one
 *        saveI optional file names for saving result
 */


#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "MatriceImage.h"
#include "CImg-1.3.0/CImg.h"


using namespace cimg_library;
using namespace std;

/*int main(){
  CImg<double> base("Imgres/baseC.ppm");
  CImg<double> detail("Imgres/detail.ppm");
  CImgDisplay fenetre=CImgDisplay();
  CImg<double> image(base);
  double lambda;

  fenetre.display(base+detail);
  
  while (!fenetre.is_closed && fenetre.key!=cimg::keyQ && fenetre.key!=cimg::keyESC){
    
    if(fenetre.button&1){
      lambda = 6 * (fenetre.mouse_y / (double)fenetre.window_height);
      image = (base + (1+lambda)*detail);
      image = image.min(255);
      
      fenetre.display(image);
      
      if(fenetre.key==cimg::keyS){
	image.save("res.ppm",-1);
      }
      
    }
  }
  
  ~image;
  ~base;
  ~detail;
  return 0;
}
*/




int main(int argc, char* argv[]) {
  double lambda = 1;
  double delta = 1;
  CImg<double> imageg(argv[1]);
  CImg<double> image1(argv[2]);
  CImg<double> image2(argv[3]);
  CImg<double> image(imageg);
  CImgDisplay fenetre=CImgDisplay();

  image2 = (image1 - image2);//.max(0.0);  
  image1 = (imageg - image1);//.max(0.0);
  
    
  fenetre.display(imageg);
  
  while (!fenetre.is_closed && fenetre.key!=cimg::keyQ && fenetre.key!=cimg::keyESC){
    
    if(fenetre.button&1){
      lambda = 6 * (fenetre.mouse_y / (double)fenetre.window_height);
      delta = 4 * (fenetre.mouse_x / (double)fenetre.window_width);
      image = ((imageg + lambda*image1 + delta*image2));
      //image = imageg + 3*image1; 
      image = image.min(255.0).max(0.0);
      //image.save(argv[4]);
      fenetre.display(image);
      
      if(fenetre.key==cimg::keyS){
	image.save(argv[4]);
      }
      
    }
  }
  
  if(fenetre.key==cimg::keyS){
	image.save(argv[4]);
  }

  ~image;
  ~image1;
  ~image2;
  return 0;
}

