/**
 *  File reconmap.cpp : small application for visualizing
 *  multi-scale decomposition using WLSfilter and depth-map
 *
 *
 *  Syntaxe : ./recon <u0> <u1> <u2> <Map>
 *  where u0 is the original image
 *        u1 the first filtered one
 *        u2 the second one
 *        Map is a depth-map (cf Raanan Fattal web site)
 *        saveI optional file names for saving result
 */


#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "MatriceImage.h"
#include "CImg-1.3.0/CImg.h"


using namespace cimg_library;
using namespace std;


int main(int argc, char* argv[]) {
  double lambda = 1;
  double delta = 1;
  CImg<double> imageg(argv[1]);
  CImg<double> image1(argv[2]);
  CImg<double> image2(argv[3]);
  CImg<double> map(argv[4]);
  CImg<double> image(imageg);
  CImgDisplay fenetre=CImgDisplay();


  image2 = (image1 - image2);
  image1 = (imageg - image1);

  image1=image1.mul((255.0-map.channel(1))/255.0);
  image2=image2.mul((map.channel(1))/255);
  
    
  fenetre.display(imageg);
  
  while (!fenetre.is_closed && fenetre.key!=cimg::keyQ && fenetre.key!=cimg::keyESC){
    
    if(fenetre.button&1){
      lambda = 8 * (fenetre.mouse_y / (double)fenetre.window_height);
      	delta = 8 * (fenetre.mouse_x / (double)fenetre.window_width);
      	 image = imageg + lambda*image1 + delta*image2;
      	
      image = image.min(255.0).max(0.0);
      
      if(fenetre.key==cimg::keyS){
	image.save(argv[5],-1);
      }
      fenetre.display(image);
      
    }
  }
  
  ~image;
  ~image1;
  ~image2;
  return 0;
}
