/* 
 *  File wls.cpp : compte the WLS filter on one image
 *  
 *  Syntaxe : ./wls <Image_source> <alpha> <lambda> <Imgage_result (Optional)>
 */



#include <iostream>
#include <string>
#include <cmath>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "CImg-1.3.0/CImg.h"
#include "MatriceImage.h"



int main(int argc, char* argv[]) {
  CImg<double> image(argv[1]);
  CImg<double> imageres(image);
  MatriceImage matim = MatriceImage(image);
  double alpha = atof(argv[2]);
  double lambda = atof(argv[3]);
  matim.computeWLS(alpha,lambda);
  imageres = matim.creerIm();
  
  
  imageres.display();
  
  if (argc == 5)
    
    imageres.save(argv[4],-1);
  
  ~image;
  ~imageres;
  return 0;
}

/*
int main(){

  CImg<double> imageg("Imgres/DecRock/rock.jpg");
  CImg<double> image1("Imgres/DecRock/dec1.jpg");
  CImg<double> image2("Imgres/DecRock/dec2.jpg");

  (3*(imageg-image1).abs()).save("Imgres/DecRock/d1.jpg",-1);
  (3*(image1-image2).abs()).save("Imgres/DecRock/d2.jpg",-1);

  return 0;

}
*/
